﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace _1055492_RadDropDownList
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            this.radDropDownList1.DataSource = employeesBindingSource;
            this.radDropDownList1.DisplayMember = "FirstName";
            this.radDropDownList1.ValueMember = "EmployeeID";
            this.radDropDownList1.ListElement.AutoSizeItems = true;
            this.radDropDownList1.DropDownStyle = Telerik.WinControls.RadDropDownStyle.DropDownList;
            
            this.radDropDownList1.ItemDataBound += radDropDownList1_ItemDataBound; 
        }

        void radDropDownList1_ItemDataBound(object sender, Telerik.WinControls.UI.ListItemDataBoundEventArgs args)
        {
            RadListDataItem item = args.NewItem;
            item.Text += " " + (item.DataBoundItem as DataRowView)["FirstName"];
            NwindDataSet.EmployeesRow row = ((item.DataBoundItem as DataRowView).Row as NwindDataSet.EmployeesRow);
            item.TextImageRelation = TextImageRelation.ImageBeforeText;
            item.Image = GetImageFromData(row.Photo);
            item.Font = new Font("Arial", 10, FontStyle.Bold);
        }

        private Image GetImageFromData(byte[] imageData)
        {
            const int OleHeaderLength = 78;
            MemoryStream memoryStream = new MemoryStream();
            if (HasOleContainerHeader(imageData))
            {
                memoryStream.Write(imageData, OleHeaderLength, imageData.Length - OleHeaderLength);
            }
            else
            {
                memoryStream.Write(imageData, 0, imageData.Length);
            }
            Bitmap bitmap = new Bitmap(memoryStream);
            return bitmap.GetThumbnailImage(55, 65, null, new IntPtr());
        }

        private bool HasOleContainerHeader(byte[] imageByteArray)
        {
            const byte OleByte0 = 21;
            const byte OleByte1 = 28;
            return (imageByteArray[0] == OleByte0) && (imageByteArray[1] == OleByte1);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // TODO: This line of code loads data into the 'nwindDataSet.Employees' table. You can move, or remove it, as needed.
            this.employeesTableAdapter.Fill(this.nwindDataSet.Employees);
        }
    }
}